-----------------------------------------------------------------------------
{- |
Module      :  Numeric.GSL.Special
Copyright   :  (c) Alberto Ruiz 2006
License     :  GPL-style

Maintainer  :  Alberto Ruiz (aruiz at um dot es)
Stability   :  provisional
Portability :  uses ffi

Wrappers for selected special functions.

<http://www.gnu.org/software/gsl/manual/html_node/Special-Functions.html#Special-Functions>
-}
-----------------------------------------------------------------------------

module Numeric.GSL.Special (
  module Numeric.GSL.Special.Airy
, module Numeric.GSL.Special.Bessel
, module Numeric.GSL.Special.Clausen
, module Numeric.GSL.Special.Coulomb
, module Numeric.GSL.Special.Coupling
, module Numeric.GSL.Special.Dawson
, module Numeric.GSL.Special.Debye
, module Numeric.GSL.Special.Dilog
, module Numeric.GSL.Special.Elementary
, module Numeric.GSL.Special.Ellint
, module Numeric.GSL.Special.Erf
, module Numeric.GSL.Special.Exp
, module Numeric.GSL.Special.Expint
, module Numeric.GSL.Special.Fermi_dirac
, module Numeric.GSL.Special.Gamma
, module Numeric.GSL.Special.Gegenbauer
, module Numeric.GSL.Special.Hyperg
, module Numeric.GSL.Special.Laguerre
, module Numeric.GSL.Special.Lambert
, module Numeric.GSL.Special.Legendre
, module Numeric.GSL.Special.Log
, module Numeric.GSL.Special.Pow_int
, module Numeric.GSL.Special.Psi
, module Numeric.GSL.Special.Synchrotron
, module Numeric.GSL.Special.Trig
, module Numeric.GSL.Special.Zeta
)
where

import Numeric.GSL.Special.Airy
import Numeric.GSL.Special.Bessel
import Numeric.GSL.Special.Clausen
import Numeric.GSL.Special.Coulomb
import Numeric.GSL.Special.Coupling
import Numeric.GSL.Special.Dawson
import Numeric.GSL.Special.Debye
import Numeric.GSL.Special.Dilog
import Numeric.GSL.Special.Elementary
import Numeric.GSL.Special.Ellint
import Numeric.GSL.Special.Erf
import Numeric.GSL.Special.Exp
import Numeric.GSL.Special.Expint
import Numeric.GSL.Special.Fermi_dirac
import Numeric.GSL.Special.Gamma
import Numeric.GSL.Special.Gegenbauer
import Numeric.GSL.Special.Hyperg
import Numeric.GSL.Special.Laguerre
import Numeric.GSL.Special.Lambert
import Numeric.GSL.Special.Legendre
import Numeric.GSL.Special.Log
import Numeric.GSL.Special.Pow_int
import Numeric.GSL.Special.Psi
import Numeric.GSL.Special.Synchrotron
import Numeric.GSL.Special.Trig
import Numeric.GSL.Special.Zeta
